﻿# Changelog TetraControl2Connect

## Version 2.1.19
* Heartbeat-Einstellungen ergänzt. Siehe Readme

## Version 2.1.20
* Heartbeat-Fehler behoben.

## Version 2.1.21
* Verarbeitung von verketteten Callouts (Also mehrere Subnetzadressen in einer Alarmierung)
* Verarbeitung von Sirenenalarmen
* Umstellung der Intervalle auf TimeSpans (siehe mitgelieferte AppSettings.json)

## Versionen 2.1.22 - 2.1.23
* Fehlerbehebungen im Zusammenhang mit verketteten Callouts

## Version 2.1.24
* Fehlerbehebungen im Zusammenhang mit verketteten Callouts
* Beachtung von Einsätzen, zu denen nachalarmiert wurde (Startzeitpunkt länger in der Vergangenheit)

## Version 2.1.25
* Unterdrückung von Status 5 und 0 in den AppSettings konfigurierbar. (BOOL "IgnoreStatus5" und "IgnoreStatus0")

## Version 2.1.26
* Unterstützung für Subnetzadressen für direkten Alarm (Neue Einstellung für jede Schleife BOOL "AlarmDirectly")
* Neue Einstellung: "AddPropertyForAlarmTexts" in den ProgramOptions: Wenn aktiv wird für alle Alarme ein Zusatzfeld mit dem Alarmtext zum Einsatz hinzugefügt

## Version 2.2.3
* Unterstützung für Callouts ohne Subnetzadressen (Vollalarm der GSSI)
  * Die Konfiguration muss nicht angepasst werden. Es werden alle Standorte alarmiert, die irgendeine Subnetzadresse mit der alarmierten GSSI in der Konfiguration haben.
* AddPropertyForAlarmTexts so angepasst, dass nur noch ein Zusatzfeld "Alarmtext TC" hinzugefügt wird und nicht mehr für jede Subnetzadresse
* Aktualisierung von Drittanbieterpaketen
* Bei Alarm aus Rückfallebene wird nun die Position des Standorts aus Connect als Position für den Einsatz übernommen (Keine Navigation mehr zur Nordsee)

## Version 2.2.4
* Neue Option unter "ProgramOptions" gibt es eine neue Einstellung "IgnoreAlarmWithoutSubnetAddresses". Dort kann man einstellen, ob Alarme, die an eine gesamte GSSI (ohne Sunetzadressen)
geschickt werden, ignoriert werden sollen. (true / false, Standard: false)

## Version 2.2.5
* Neue Option unter "ProgramOptions" gibt es eine neue Einstellung "AcceptCalloutsForSirens". Dort kann eingestellt werden, ob auch Alarmierungen für Sirenen 
verarbeitet werden sollen. (Callouts für Sirenen beginnen mit einem Steuerzeichen z.B. $2002). (true / false, Standard: false)

## Version 2.2.6
* Die Subnetzadressen werden nun bei Fallback-Alarmen nicht mehr in den Sachverhalt geschrieben, sondern vorher rausgefiltert
* Als Meldender (Reporter) wurde jetzt Name und ISSI des Absenders des Callouts hinzugefügt

## Version 2.2.7
* Kleinere Fehlerbehebungen

## Version 2.3.0
* Schweregrad (Severity) von Callouts wird nun als Stichwort für Fallback-Einsätze verwendet (Abschaltbar via SeverityOptions-> UseServerityTranslationAsKeyword auf false setzen)
* Neue Sektion "SeverityOptions" in den AppSettings (optional)
  * Standardmäßig eingetragen sind dort die Schweregrad-Übersetzungen von Hessen

## Version 2.3.1
* Falls am TetraControl ein Pager und ein HRT oder MRT angeschlossen sind, werden die "Gesendet:"-SDS vom Funkgerät hier ignoriert, um nicht zwei Einsätze in Connect zu erzeugen.

## Version 2.3.2
* Fehlerbehebungen, dass alarmierte Subnetzadressen bei Fallback-Alarmen mehrfach im RIC-Feld standen
* Statuscode 429 (Too many Requests) von Connect wird nun mit Retry behandelt

## Version 2.3.3
* Tippfehler in (Standard) Schweregrad "Hilfeleistung" behoben
* Fehler mit dem fehlerhaften Update von Koordinatne bei Einsatz-Updates behoben (Nach Update von T2C wurden die Koordinaten nicht mit übertragen und damit von OSM neu geholt)

## Version 2.3.4
* Karenzzeit für Einsatz-Aktualisierung auf Erstellt / Geupdated in den letzten 10 Minuten erhöht

## Version 2.3.5
* Einstellung "OnlyVehicleData" in den ProgramOptions durch granularere Einstellungen ersetzt. Neu sind:
  * SendVehicleStatus -> Fahrzeugstatus übertragen (Standard: true)
  * SendVehiclePositions -> Fahrzeugpositionen übertragen (Standard: true)
  * SendUserOperationStatus -> Einsatzrückmeldungen von Benutzern übertragen (Standard: true)
  * SendUserAvailability -> Benutzer-Verfügbarkeit (Taktische Verfügbarkeit) übertragen (Standard: true)
  * SendAlarms -> Callouts (Alarmierungen) auswerten und übertragen (Standard: true)
* "OnlyVehicleData" ist nicht mehr zu verwenden.

## Version 2.3.6
* Fahrzeugpositionen werden zwischengespeichert und Updates nur an Connect übertragen, wenn die Werte um mehr als 0.00008 verändern.
* Bei einem erstellten Einsatz wird die Quelle nun in das dafür vorgesehene Feld geschrieben

## Version 2.3.7
* Fehler (Vertauschter Längen- und Breitengrad) bei den Fahrzeugpositionen behoben

## Version 2.3.8
* Fehlerhafte Fallback-Alarmierung bei ungünstiger Anordnung/Abfolge mehrerer aktiver Einsätze in Connect behoben
* Mehr Intelligenz eingebaut, um mehrfache Fallback-Alarme für den gleichen Einsatz bei mehreren ausgelösten Schleifen zu verhindern.

## Version 2.3.9
* Bessere Parallelverarbeitung

## Version 2.3.10
* Fehlerbehebungen

## Version 2.3.11
* Status 9 ignorieren hinzugefügt. Neue Einstellung "IgnoreStatus9" unter ProgramOptions hinzugefügt. Details siehe Readme.

## Version 2.3.12
* Weiter verbesserte Parallelverarbeitung

## Version 2.3.13
* Verbessertes Logging
* Verbesserte Kompatibilität zu älteren TetraControl-Versionen

## Version 2.4.0
* Übersetzungen für Sirenen-Steuerzeichen hinzugefügt (optional, standardmäßig nicht aktiv). 
	* Neuer (optionaler) Abschnitt in den AppSettings: "SirenCalloutOptions"
	* "UseSirenCodeTranslationAsKeyword" -> Das Steuerzeichen der Sirene soll als Stichwort für den Einsatz verwendet werden (Bsp.: $2000 -> Warnung der Bevölkerung, Standard: false)
	* "SirenCodeTranslations" -> Hier können die Übersetzungen (analog zu den Schweregrad-Übersetzungen eingetragen werden). Standard ist Hessen.

## Version 2.5.0
* Neue Einstellung unter ProgramOptions "UpdateExistingOperations" hinzugefügt (optional, standardmäßig true)
	* Wenn auf true, dann wird ein vorhandener Einsatz in Connect mit den ausgelösten Subadressen aktualisiert (so wie es vorher immer war)
	* Wenn auf false, dann wird der Einsatz nicht aktualisiert, jedoch wird weiterhin ein Fallback-Einsatz erstellt, falls kein Einsatz aktiv gefunden wurde.

## Version 2.5.2
* Neue Konfigurationsmöglichkeit "PatternOptions" ergänzt.
	* Informationen über den Einsatz können hier mittels Regex aus dem SDS Text extrahiert werden
	* Die dabei im Feld "RIC" ausgelesenen Werte werden mit den Einträgen in den Subadressen mit einem Contains verglichen, um Einsätze auf Standorte aufzuteilen

## Version 2.5.4
* Kleinere Fehlerbehebungen

## Version 2.5.5
* Kleinere Fehlerbehebungen

## Version 2.5.6
* Fehlerbehebung SDS-Auswerung Meldender
* Aktualisierung von Drittanbieterpaketen

## Version 2.6.0
* Aktualisierung von Drittanbieterpaketen

## Version 2.6.1
* Bei Verwendung der SDS-Patternauswertung: Fallback wenn Stichwort oder Stadt leer ist